package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Check for voltage range.
 */
public class B_TwinVoltageRange {

    /**
     * <p>Within the European Union mains power supply varies from 220 to 240 volts inclusive. Other
     * countries e.g. North / Central America or Japan allow voltages ranging from 100 to 127 inclusive.</p>
     *
     * <p>Check whether a given voltage is within either of these two ranges.</p>
     *
     * @param measurement Measured voltage.
     * @return <code>true</code> if voltage is within either of two ranges [100, 127] or [220, 240].
     *    <code>false</code> otherwise.
     */
    public static boolean isWithinValidLimits(int measurement) {

        return 220 <= measurement && measurement <= 240 ||
               100 <= measurement && measurement <= 127;
    }
    private B_TwinVoltageRange(){/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
