package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Company revenues and expenses.
 */
public class C_Finance {

    /**
     * <p>Calculate a company's revenue / expenses balance.</p>
     *
     * <p>A company's balance is being defined by the difference of all revenues and expenses respectively. Example:</p>
     *
     * <pre> revenues = {4000, 20000, 2500, 10000} ⟹ sum of revenues =  36500
     * expenses = {3000, 16000, 1000}        ⟹ sum of expenses = -20000
     *                                           -----------------------
     *                                                  <b>balance =  16500</b></pre>
     * @param revenues Company revenues.
     * @param expenses Company expenses.
     * @return Difference of all revenues and expenses
     */
    public static int getBalance(int[] revenues , int[] expenses) {
        int balance = 0;
        for (final int r: revenues) {
            balance += r;
        }
        for (final int e: expenses) {
            balance -= e;
        }
        return balance;
    }

    private C_Finance(){/* Ignore me: My sole purpose is suppressing default constructor javadoc generation */}
}
