package de.hdm_stuttgart.mi.sd1.task2;

/**
 * <p>Months of year.</p>
 * <p>Note: There usually is nothing to change here. Solving this task requires
 * working on {@link Zodiac#getZodiac(Month, int)}</p>
 */
public enum Month {
    /**
     * Month January.
     */
    JAN(31),
    /**
     * Month February.
     */
    FEB(29),
    /**
     * Month March.
     */
    MAR(31),
    /**
     * Month April.
     */
    APR(30),
    /**
     * Month May.
     */
    MAY(31),
    /**
     * Month June.
     */
    JUN(30),
    /**
     * Month July.
     */
    JUL(31),
    /**
     * Month August.
     */
    AUG(31),
    /**
     * Month September.
     */
    SEP(30),
    /**
     * Month October.
     */
    OCT(31),
    /**
     * Month November.
     */
    NOV(30),
    /**
     * Month December.
     */
    DEC(31);

    /**
     * A month is being supplied its maximum number of days, 29 for February due to leap years.
     * @param numberOfDays Total number of days e.g. 31 for January.
     */
     Month(int numberOfDays) {
        this.numberOfDays = numberOfDays;
    }

    /**
     * <p>Current month's number of days e.g. 31 for January.</p>
     */
    public final int numberOfDays;
}
