package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class B_TwinVoltageRangeTest extends ExaminationTestDefaults {

    @Marking(points = 12)
    @Test
    public void test_100_singleValues() {
        assertVoltage(false, 0);
        assertVoltage(false, 99);
        assertVoltage(true, 100);
        assertVoltage(true, 115);
        assertVoltage(true, 127);
        assertVoltage(false, 128);
        assertVoltage(false, 219);
        assertVoltage(true, 220);
        assertVoltage(true, 227);
        assertVoltage(true, 240);
        assertVoltage(false, 241);
        assertVoltage(false, 300);
    }
    @Marking(points = 4)
    @Test
    public void test_200_fillRanges() {
        assertVoltageRange(false, -100, 99);
        assertVoltageRange(true, 100, 127);
        assertVoltageRange(false, 128 , 219);
        assertVoltageRange(true, 220, 240);
        assertVoltageRange(false, 241 , 1000 );
    }

    private static void assertVoltage(boolean expected, int value) {
            Assert.assertEquals("A voltage " + value + " should yield " + expected,
                    expected, B_TwinVoltageRange.isWithinValidLimits(value));
    }
    private static void assertVoltageRange(boolean expected, int start, int end) {
        for (int i = start; i <= end; i++) {
            final boolean actual = B_TwinVoltageRange.isWithinValidLimits(i);

            if (actual != expected) {
                Assert.assertEquals(
                        "Value " + i + " should yield " + expected + ", wanna set a breakpoint for debugging?",
                        expected,
                        B_TwinVoltageRange.isWithinValidLimits(i));
            }
        }
    }
}
